import javax.microedition.lcdui.*;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;
import java.util.Vector;

public class ConnectionList extends Form implements CommandListener, Receiver {
 midlet midlet;
 Displayable parent;
 public Vector items,hours;
 public StringItem [] Times;
 public boolean [] Flags;
 public long [] Deltas;
 public Timer timer=null;
 public midletTimerTask timertask=null;
 timeFunc timeFunc;
 String header;
 int i,p,k;
 String s;

 public void setSystemTime () {
  Times[0].setText (timeFunc.getTimeStr());
  for (int p=1; p<=items.size(); p++) {
   if (Flags[p]==true) Times[p].setText (timeFunc.getTimeStr(timeFunc.getTime()+Deltas[p]));
  }
 }
  
 ConnectionList (midlet midlet, Displayable parent, String header, Vector items, Vector hours) {
  super(header);
  this.midlet = midlet;
  this.parent = parent;
  this.items = items;
  this.hours = hours;
  this.header = header;

  addCommand(midlet.BackCommand);
  Display.getDisplay(midlet).setCurrent(this);
  setCommandListener (this);

  timeFunc = new timeFunc ();
  Times = new StringItem [items.size()+1];
  Flags = new boolean [items.size()+1];
  Flags[0]=true;
  Deltas = new long [items.size()+1];
  Deltas[0]=0;
  for (int i=1; i<items.size()+1; i++) {
   Flags[i]=false;
   Deltas[i]=0;
  }
  if (items.size()<1) {
   Times[0] = new StringItem (Locale.WarningHeader,Locale.VoidListMessage);
   append (Times[0]);
   return;
  }

  Times[0] = new StringItem (Locale.SysTimeHeader,timeFunc.getTimeStr());
  append (Times[0]);
 
  for (i=0; i<items.size(); i++) {
   Times[i+1]=new StringItem (items.elementAt(i).toString(),Locale.noTimeStr);
   append (Times[i+1]);
  }

  timer = new Timer();
  timertask = new midletTimerTask (this);
  timer.scheduleAtFixedRate (timertask,0,(long)1000);

  i=-1;
  nextConnection ();
 }

 private void nextConnection () {
  if (i<items.size()-1) {
   p=0;
   i++;
   s=Times[i+1].getLabel ();
   k = s.length ();
   if (k>10) k=10; //    
   setTitle (s.substring(0,k)+" ["+(p+1)+"]");
   new InternetConnection (s,this,i);
  }
  else {
   setTitle (header);
  }
 }

 String sd;
 long dif;

 public void getTime (String url, long time, long delta, int i) {
  dif = time - timeFunc.getTime();

  long hp;
  try { hp=Long.parseLong (hours.elementAt(i).toString()); }
  catch (NumberFormatException e) { hp=0; }
  hp*=3600000;
  if (hp!=0) dif+=hp;

  Deltas[i+1] = dif;
//System.out.println ((i+1)+": "+Deltas[i+1]);
  dif/=1000;
  if (dif==0) sd="";
  else if (dif<-60) sd=" [<<]";
  else if (dif>60) sd=" [>>]";
  else sd = " ["+dif+"]";
  Times[i+1].setLabel (Times[i+1].getLabel()+sd);
  if (options.correction!=0) time+=delta/2;
  Times[i+1].setText (timeFunc.getTimeStr(time));
  Flags[i+1]=true;
  nextConnection ();
 }

 public void failure(String url,int i) {
  if (p<options.attempts) {
   p++;
   setTitle (s.substring(0,k)+" ["+(p+1)+"]");
   new InternetConnection (s,this,i);
  }
  else {
   nextConnection ();
  }
 }

 public void commandAction(Command c, Displayable d)  {
  if (timertask != null) {
   timertask.cancel();
   timertask = null;
  }
  if (timer != null) {
   timer.cancel();
   timer = null;
  }
  Display.getDisplay(midlet).setCurrent(parent);
 }

}        