import javax.microedition.lcdui.*;
import java.util.*;

public class itemsList extends List implements CommandListener { 
 midlet midlet;
 Displayable parent;
 Command AddCommand, ChangeCommand, DeleteCommand, UpCommand, DownCommand;
 Form editForm;
 TextField text,correct;
 String title;
 int n;
 int mode; //0-,1-,2-

 itemsList (midlet midlet, Displayable parent, String title) { 
  super (title + ": "+midlet.servers.size(), IMPLICIT);
  this.midlet = midlet;
  this.parent = parent;
  this.title = title;

  for (int i=0; i<midlet.servers.size(); i++) append (midlet.servers.elementAt(i).toString(),null);

  AddCommand = new Command(Locale.AddCommand, Command.ITEM, 1);
  ChangeCommand = new Command(Locale.ChangeCommand, Command.ITEM, 1);
  DeleteCommand = new Command(Locale.DeleteCommand, Command.ITEM, 1);
  UpCommand = new Command(Locale.UpCommand, Command.ITEM, 1);
  DownCommand = new Command(Locale.DownCommand, Command.ITEM, 1);
  
  addCommand(midlet.BackCommand); 
  addCommand(AddCommand); 
  addCommand(ChangeCommand); 
  addCommand(DeleteCommand); 
  addCommand(UpCommand); 
  addCommand(DownCommand); 

  editForm = new Form (Locale.serverHeader);
  editForm.addCommand(midlet.BackCommand);
  editForm.addCommand(midlet.OkCommand);
  text=new TextField (Locale.urlHeader, "", 100, TextField.URL);
  editForm.append (text);
  correct=new TextField (Locale.correctHeader, "", 3, TextField.NUMERIC);
  editForm.append (correct);
  editForm.setCommandListener(this);

  mode=0;
 }

 public void setHeader () {
  setTitle (title + ": "+midlet.servers.size());
 }

 public void show () {
  setCommandListener (this);
  Display.getDisplay(midlet).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) {
  if (c == midlet.BackCommand) { 
   if (mode==0) {
    Display.getDisplay(midlet).setCurrent(parent);
   }
   else {
    mode=0;
    Display.getDisplay(midlet).setCurrent(this);
   }
  } 
  else if (c== AddCommand) {
   n = getSelectedIndex ();
   mode=1;
   text.setString ("");
   correct.setString ("0");
   Display.getDisplay(midlet).setCurrent(editForm);
  }
  else if (c== ChangeCommand) {
   n = getSelectedIndex ();
   if (n>-1) {
    mode=2;
    text.setString (getString(n));
    int hh;
    try { hh=Integer.parseInt(midlet.corrections.elementAt(n).toString()); }
    catch (NumberFormatException e) { hh=0; }
    correct.setString (""+hh);
    Display.getDisplay(midlet).setCurrent(editForm);
   }
  }
  else if (c== DeleteCommand) {
   if (size()>0) {
    n = getSelectedIndex ();
    if (n>-1) {
     delete (n);
     midlet.servers.removeElementAt (n);
     midlet.corrections.removeElementAt (n);
     options.changed=true;
     if (size()<1) new Message (midlet, this, Locale.WarningHeader).show (Locale.VoidListMessage);
     setHeader ();
    }
   }
  }
  else if (c== UpCommand) {
   if (size()>1) {
    n = getSelectedIndex ();
    if (n>0) {
     String s=getString (n);
     String s2=midlet.corrections.elementAt(n).toString();
     delete (n);
     insert (n-1,s,null);
     midlet.servers.removeElementAt (n);
     midlet.corrections.removeElementAt (n);
     midlet.servers.insertElementAt (s,n-1);
     midlet.corrections.insertElementAt (s2,n-1);
     options.changed=true;
    }
   }
  }
  else if (c== DownCommand) {
   if (size()>1) {
    n = getSelectedIndex ();
    if (n<size()-1) {
     String s=getString (n);
     String s2=midlet.corrections.elementAt(n).toString();
     delete (n);
     midlet.servers.removeElementAt (n);
     midlet.corrections.removeElementAt (n);
     if (n==size()-1) {
      append (s,null);
      midlet.servers.addElement (s);
      midlet.corrections.addElement (s2);
     }
     else {
      insert (n+1,s,null);
      midlet.servers.insertElementAt (s,n+1);
      midlet.corrections.insertElementAt (s2,n+1);
     }
     options.changed=true;
    }
   }
  }
  else if (c == midlet.OkCommand) {
   String txt = text.getString().trim();
   String cor= correct.getString().trim();
   if (txt.length()<1 || cor.length()<1) {
    new Message (midlet, editForm, Locale.WarningHeader).show (Locale.VoidFieldMessage);
    return;
   }
   int sdvig;
   try { sdvig=Integer.parseInt (cor);  }
   catch (NumberFormatException e) {
    new Message (midlet, editForm, Locale.WarningHeader).show (Locale.NumberFormatMessage);
    return;
   }
   if (sdvig<-12 || sdvig>11) {
    new Message (midlet, editForm, Locale.WarningHeader).show (Locale.HourCorrectionMessage);
    return;
   }

   if (mode == 1) {
    if (n<0) {
     append (txt, null);
     midlet.servers.addElement (txt);
     midlet.corrections.addElement (cor);
    }
    else {
     insert (n, txt, null);
     midlet.servers.insertElementAt (txt,n);
     midlet.corrections.insertElementAt (cor,n);
    }
    setHeader ();
    options.changed=true;
   }
   else if (mode == 2) {
    set (n, txt, null);
    midlet.servers.setElementAt (txt,n);
    midlet.corrections.setElementAt (cor,n);
    options.changed=true;
   }
   mode=0;
   Display.getDisplay(midlet).setCurrent(this);
  }
 }

}